<?php

function xoops_module_update_xoopensim(&$module, $prev_version) 
{
	global $xoopsDB;


	// for v1.25
	if ($prev_version < 125) {
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_offline_message').' ('.
								'to_uuid   		varchar(36) NOT NULL, '.
								'from_uuid 		varchar(36) NOT NULL, '.
								'message   		text        NOT NULL, '.
								'KEY to_uuid (to_uuid) '.
				    	 ') TYPE=MyISAM');
	}



	// for v1.33
	if ($prev_version < 133) {
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_prof_classifieds').' ('.
								'classifieduuid  	char(36) NOT NULL, '.
								'creatoruuid 	 	char(36) NOT NULL, '.
								'creationdate 	 	int(20) NOT NULL, '.
								'expirationdate  	int(20) NOT NULL, '.
								'category 		 	varchar(20) NOT NULL, '.
								'name 			 	varchar(255) NOT NULL, '.
								'description 	 	text NOT NULL, '.
								'parceluuid 	 	char(36) NOT NULL, '.
								'parentestate 	 	int(11) NOT NULL, '.
								'snapshotuuid 	 	char(36) NOT NULL, '.
								'simname 		 	varchar(255) NOT NULL, '.
								'posglobal 		 	varchar(255) NOT NULL, '.
								'parcelname 	 	varchar(255) NOT NULL, '.
								'classifiedflags 	int(8) NOT NULL, '.
								'priceforlisting 	int(5) NOT NULL, '.
								'PRIMARY KEY (classifieduuid) '.
				    	 ') TYPE=MyISAM');

		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_prof_usernotes').' ('.
								'id                 int(11) NOT NULL auto_increment,'.
								'useruuid 			varchar(36) NOT NULL, '.
								'targetuuid 		varchar(36) NOT NULL, '.
								'notes 				text NOT NULL, '.
								'PRIMARY KEY (id),'.
								'UNIQUE KEY  useruuid (useruuid, targetuuid) '.
				    	 ') TYPE=MyISAM');

		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_prof_userpicks').' ('.
								'pickuuid 			varchar(36) NOT NULL, '.
								'creatoruuid 		varchar(36) NOT NULL, '.
								"toppick 			enum('true','false') NOT NULL, ".
								'parceluuid 		varchar(36) NOT NULL, '.
								'name 				varchar(255) NOT NULL, '.
								'description 		text NOT NULL, '.
								'snapshotuuid 		varchar(36) NOT NULL, '.
								'user 				varchar(255) NOT NULL, '.
								'originalname 		varchar(255) NOT NULL, '.
								'simname 			varchar(255) NOT NULL, '.
								'posglobal 			varchar(255) NOT NULL, '.
								'sortorder 			int(2) NOT NULL, '.
								"enabled 			enum('true','false') NOT NULL, ".
								'PRIMARY KEY (pickuuid) '.
				    	 ') TYPE=MyISAM');

		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_prof_userprofile').' ('.
								'useruuid 				varchar(36) NOT NULL, '.
								'profilePartner 		varchar(36) NOT NULL, '.
 	 							'profileImage 			varchar(36) NOT NULL, '.
								'profileAboutText 		text NOT NULL, '.
								'profileAllowPublish 	binary(1) NOT NULL, '.
								'profileMaturePublish	binary(1) NOT NULL, '.
								'profileURL 			varchar(255) NOT NULL, '.
								'profileWantToMask 		int(3) NOT NULL, '.
								'profileWantToText 		text NOT NULL, '.
								'profileSkillsMask 		int(3) NOT NULL, '.
								'profileSkillsText 		text NOT NULL, '.
 			 					'profileLanguagesText 	text NOT NULL, '.
 	 							'profileFirstImage 		varchar(36) NOT NULL, '.
								'profileFirstText 		text NOT NULL, '.
 			 					'PRIMARY KEY (useruuid) '.
				    	 ') TYPE=MyISAM');

		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_prof_usersettings').' ('.
								'useruuid 			varchar(36) NOT NULL, '.
								"imviaemail 		enum('true','false') NOT NULL, ".
								"visible 			enum('true','false') NOT NULL, ".
								'email 				varchar(254) NOT NULL, '.
								'PRIMARY KEY (useruuid) '.
				    	 ') TYPE=MyISAM');
	}



	// for Mute List
	if ($prev_version < 144) {
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_mute_list').' ('.
								'agentID		varchar(36)  NOT NULL, '.
								'muteID			varchar(36)  NOT NULL, '.
								'muteName		varchar(255) NOT NULL, '.
								'muteType 		int(10) unsigned NOT NULL default 0, '.
								'muteFlags 		int(10) unsigned NOT NULL default 0, '.
								'timestamp		int(11) unsigned NOT NULL default 0, '.
								'PRIMARY KEY  (AgentID, MuteID, MuteName) '.
				    	 ') TYPE=MyISAM');
	}



	// for Login Screen
	if ($prev_version < 145) {
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_login_screen').' ('.
								'id       		int(10) unsigned NOT NULL auto_increment, '.
								'title			varchar(255) NOT NULL DEFAULT "", '.
								'information	text NOT NULL default "", '.
								'borderColor  	varchar(20) NOT NULL default "white", '. 
								'timestamp 		int(11) unsigned NOT NULL default "0", '.
								'PRIMARY KEY (id) '.
						') TYPE=MyISAM');
	}



	// for OS Search
	if ($prev_version < 150) {
		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_classifieds'));

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_hostsregister'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_hostsregister').' ('.
								'host 			varchar(255) NOT NULL, '.
								'port 			int(5)  NOT NULL, '.
								'register 		int(10) NOT NULL, '.
								'nextcheck 		int(10) NOT NULL, '.
								'checked 		tinyint(1) NOT NULL, '.
								'failcounter 	int(10) NOT NULL, '.
								'PRIMARY KEY (host,port) '.
						') ENGINE=InnoDB ROW_FORMAT=DEFAULT');

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_allparcels'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_allparcels').' ('.
								'regionUUID 	char(36)  NOT NULL, '.
								'parcelname 	varchar(255) NOT NULL, '.
								'ownerUUID 		char(36) NOT NULL default "00000000-0000-0000-0000-000000000000", '.
								'groupUUID 		char(36) NOT NULL default "00000000-0000-0000-0000-000000000000", '.
								'landingpoint 	varchar(255) NOT NULL, '.
								'parcelUUID 	char(36) NOT NULL default "00000000-0000-0000-0000-000000000000", '.
								'infoUUID 		char(36) NOT NULL default "00000000-0000-0000-0000-000000000000", '.
								'parcelarea 	int(11) NOT NULL, '.
								'PRIMARY KEY  (parcelUUID), '.
								'KEY regionUUID (regionUUID) '.
						') TYPE=MyISAM');

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_parcels'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_parcels').' ('.
								'regionUUID 		char(36)  NOT NULL, '.
								'parcelname 		varchar(255) NOT NULL, '.
								'parcelUUID 		char(36)  NOT NULL, '.
								'landingpoint 		varchar(255) NOT NULL, '.
								'description 		varchar(255) NOT NULL, '.
								'searchcategory 	varchar(50)  NOT NULL, '.
								"build 				enum('true','false') NOT NULL default 'false', ".
								"script 			enum('true','false') NOT NULL default 'false', ".
								"public 			enum('true','false') NOT NULL default 'false', ".
								'dwell 				float NOT NULL default "0", '.
								'infouuid 			char(36)  NOT NULL default "", '.
								"mature				varchar(10) NOT NULL default 'PG', ".
								'PRIMARY KEY (regionUUID,parcelUUID), '.
								'KEY name (parcelname), '.
								'KEY description (description), '.
								'KEY searchcategory (searchcategory), '.
								'KEY dwell (dwell) '.
						') ENGINE=InnoDB ROW_FORMAT=DEFAULT');

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_parcelsales'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_parcelsales').' ('.
								'regionUUID 	char(36)  NOT NULL, '.
								'parcelname 	varchar(255) NOT NULL, '.
								'parcelUUID 	char(36)  NOT NULL, '.
								'area 			int(6)  NOT NULL, '.
								'saleprice 		int(11) NOT NULL, '.
								'landingpoint 	varchar(255) NOT NULL, '.
								'infoUUID 		char(36)  NOT NULL default "00000000-0000-0000-0000-000000000000", '.
								'dwell 			int(11) NOT NULL, '.
								'parentestate 	int(11) NOT NULL default "1", '.
								'mature 		varchar(10) NOT NULL default "PG", '.
								'PRIMARY KEY  (regionUUID,parcelUUID) '.
						') ENGINE=InnoDB ROW_FORMAT=DEFAULT');

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_events'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_events').' ('.
    							'uid			mediumint(8) unsigned NOT NULL default 0,'.
								'owneruuid 		char(36) NOT NULL, '.
								'name 			varchar(255) NOT NULL, '.
    							'eventid		int(11)  NOT NULL auto_increment,'.
								'creatoruuid 	char(36) NOT NULL, '.
								'category 		int(2) NOT NULL, '.
								'description 	text NOT NULL, '.
								'dateUTC 		int(10) NOT NULL, '.
								'duration 		int(10) NOT NULL, '.
								'covercharge 	int(10) NOT NULL, '.
								'coveramount 	int(10) NOT NULL, '.
								'simname 		varchar(255) NOT NULL, '.
								'globalPos 		varchar(255) NOT NULL, '.
								'eventflags 	int(1) NOT NULL, '.
								'PRIMARY KEY  (eventid) '.
						') ENGINE=InnoDB ROW_FORMAT=DEFAULT');

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_regions'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_regions').' ('.
								'regionname 	varchar(255) NOT NULL, '.
								'regionuuid 	char(36)  NOT NULL, '.
								'regionhandle 	varchar(255) NOT NULL, '.
								'url 			varchar(255) NOT NULL, '.
								'owner 			varchar(255) NOT NULL, '.
								'owneruuid 		char(36)  NOT NULL, '.
								'PRIMARY KEY  (regionuuid) '.
						') ENGINE=InnoDB ROW_FORMAT=DEFAULT');

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_popularplaces'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_popularplaces').' ('.
								'parcelUUID 	char(36) NOT NULL, '.
								'name 			varchar(255) NOT NULL, '.
								'dwell 			float NOT NULL, '.
								'infoUUID 		char(36) NOT NULL, '.
								'has_picture 	tinyint(4) NOT NULL, '.
								'mature 		tinyint(4) NOT NULL '.
						') ENGINE=InnoDB ROW_FORMAT=DEFAULT');

		$xoopsDB->queryF('DROP TABLE IF EXISTS '.$xoopsDB->prefix('xoopensim_search_objects'));
		$xoopsDB->queryF('CREATE TABLE '.$xoopsDB->prefix('xoopensim_search_objects').' ('.
								'objectuuid 	char(36)  NOT NULL, '.
								'parceluuid 	char(36)  NOT NULL, '.
								'location 		varchar(255) NOT NULL, '.
								'name 			varchar(255) NOT NULL, '.
								'description 	varchar(255) NOT NULL, '.
								'regionuuid 	char(36)  NOT NULL default "", '.
								'PRIMARY KEY  (objectuuid,parceluuid) '.
						') ENGINE=InnoDB ROW_FORMAT=DEFAULT');

	}

	return true;
}

?>
